<script src="@#file#(webgl-math.js)" type="text/javascript"></script>
<script src="@#file#(webgl-basic.js)" type="text/javascript"></script>
<script src="@#file#(webgl-view.js)" type="text/javascript"></script>
<script src="@#file#(webgl-proj.js)" type="text/javascript"></script>
<script src="@#file#(osvj.js)" type="text/javascript"></script>

<script type="text/javascript">
  var ld3 = null;

  function start() {
    ld3 = new lightningDemo2('myCanvas3', 4);

    ld3.scene.toggleAmbient(true);
    ld3.scene.toggleDiffuze(true);
    ld3.scene.toggleSpecular(true);

    ld3.startAnimation();
  }
</script>

  <p>
    Phongov model osvjetljavanja najkompleksiji je od ova tri opisana jer radi najviše
    izračuna po slikovnom elementu.
  </p>

  <p>
    Kao i kod Gouraudovog sjenčanja, pretpostavlja se da vrhovi imaju pridružene normale
    (ili da ćemo ih izračunati i pridružiti vrhovima).
  </p>

  <p>
    Za razliku od Gouraudovog sjenčanja, kod Phongovog se sjenčanja po bridovima a zatim
    po vodoravnom nizu slikovnih elemenata interpoliraju normale i 3D-koordinate svakog
    slikovnog elementa. Zatim se, u trenutku kada treba osvijetliti slikovni element
    na položaju (<i>x</i><sub>j</sub>,<i>y</i><sub>i</sub>), za njega provodi kompletan
    izračun osvjetljenja (primjerice Phongovim modelom osvjetljavanja).
  </p>

<figure class="mlFigure" style="margin-bottom: 20px;">
<img src="@#file#(phong-p.svg)">
<figcaption>Slika 1. Phongovo sjenčanje. Normale su zadane u vrhovima. Uzduž osi <i>y</i> (po bridovima) interpoliramo normale (i koordinate slikovnih elemenata u 3D). Za fiksni <i>y</i> ponovno interpoliramo normale i koordinate slikovnog elementa u 3D uzduž zrake (od normale na lijevom bridu do normale na desnom bridu). Na kraju u svakom slikovnom elementu nanovo računamo čitav model osvjetljavanja.</figcaption>
</figure>

  <p>
    Interaktivni primjer koji koristi Phongov model osvjetljavanja dan je u nastavku.
  </p>

  <p><canvas id="myCanvas3" width="640" height="480">
    Your browser doesn't appear to support the 
    &lt;canvas&gt; element.
  </canvas></p>

  <p>
    Primjetite kako ovaj model generira najglađi prikaz: granice između bridova poligona postale
    su praktički nevidljive, unatoč činjenici da koristimo relativno grubu poligonizaciju. Uz finiju
    poligonizaciju, rezultati će biti još kvalitetniji. Primjetite također kako odbljesak glatko klizi
    po površini kugle.
  </p>

<script type="text/javascript">
start();
</script>

